//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  (c) 2010-present DEMOS plan GmbH.
//
//  This file is part of the package demosplan,
//  for more information see the license file.
//
//  All rights reserved
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//  component: c-styled-html
//
//  Styles html content. Optimized for visualizing structure and readability.
//
//  Other styles existing for the sole purpose of styling content should be moved here.

@use 'sass:math';

.c-styled-html {
    @extend %break-words-with-hyphens;

    $styled-html-zoom-factor: 1.2;

    // Custom heading styles are applied to differentiate from body copy while maintaining visual hierarchy.
    // To be distinguishable from bold elements, a second differentiator is always used (color, text-transform,
    // or the extra small font size set on h6.
    h4,
    h5,
    h6 {
        font-family: $bold-font-family;
        font-weight: $bold-font-weight;
    }

    h4 {
        color: $dp-color-main;
    }

    h5 {
        text-transform: uppercase;
    }

    p > a {
        @include keyboard-focus($padded: true);

        // Links should look like links, no matter which color they are.
        text-decoration: underline;
    }

    table {
        width: calc(100% - #{$dp-border-thickness * 2});
        border-collapse: separate;

        tbody {
            background: $dp-color-neutral-light-3;
        }

        tr {
            &:nth-child(2n) {
                background: $dp-color-border-default;
            }

            &:first-child td {
                border-top: $dp-color-border-default;
            }

            &:last-child td {
                border-bottom: $dp-border-thickness solid $dp-color-border-default;
            }

            td:first-child {
                border-left: $dp-border-thickness solid $dp-color-border-default;
            }

            td:last-child {
                border-right: $dp-border-thickness solid $dp-color-border-default;
            }
        }
    }

    table + p > i {
        display: inline-block;
        margin-top: $inuit-base-spacing-unit--small;

        color: $dp-color-neutral-base;
    }

    ol,
    ul {
        margin-left: $inuit-base-spacing-unit--large;
        min-width: 50px;

        > li {
            margin-bottom: $inuit-base-spacing-unit--small;
        }
    }

    img {
        height: auto;
        max-width: 100%;
    }

    // Styling of <del> and <ins> tags should match styling in version sidebar in assessment table and styling in tiptap

    del {
        background-color: $dp-color-text-deleted-bg;
    }

    ins {
        background-color: $dp-color-text-inserted-bg;
    }

    &.c-styled-html--large {
        font-size: math.div(($styled-html-zoom-factor * $inuit-base-font-size), 16px) * 1em;

        h1 {
            @include inuit-font-size(($styled-html-zoom-factor * $dp-font-size-h1), 1.3);
        }

        h2 {
            @include inuit-font-size(($styled-html-zoom-factor * $dp-font-size-h2), 1.3);
        }

        h3 {
            @include inuit-font-size(($styled-html-zoom-factor * $dp-font-size-h3), 1.4);
        }

        h4 {
            @include inuit-font-size(($styled-html-zoom-factor * $dp-font-size-h4), 1.4);
        }

        h5 {
            @include inuit-font-size($styled-html-zoom-factor * $dp-font-size-h5);
        }

        h6 {
            @include inuit-font-size($styled-html-zoom-factor * $dp-font-size-h6);
        }

        table {
            font-size: $styled-html-zoom-factor * $base-font-size;
        }
    }
}
